/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import data.IMotif;
import data.IPhrase;
import data.MotifType;
import java.awt.Rectangle;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.JOptionPane;
import motif.MotifDetection;

/**
 *
 * @author smuRf
 */
public class DetectionDialog extends javax.swing.JDialog {
    private IPhrase detectionPhrase;
    private MainGui parent;
    
    /**
     * Creates new form DetectionDialog
     */
    public DetectionDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        
        this.parent = (MainGui)parent;
        this.getRootPane().setDefaultButton(btnDetect);
        
        Rectangle parentBounds = this.parent.getBounds();
        this.setBounds((int)(parentBounds.getWidth()/2-getBounds().getWidth()/2) + (int)parentBounds.getX(), 
                       (int)(parentBounds.getHeight()/2-getBounds().getHeight()/2) + (int)parentBounds.getY(), 
                       (int)getBounds().getWidth(), (int)getBounds().getHeight());
    }
    
    public void setIPhrase(IPhrase iPhrase)
    {
        detectionPhrase = iPhrase;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnlOptions = new javax.swing.JPanel();
        pnlGeneral = new javax.swing.JPanel();
        lblMinMotifSize = new javax.swing.JLabel();
        lblMaxMotifSize = new javax.swing.JLabel();
        slMinMotifSize = new javax.swing.JSlider();
        slMaxMotifSize = new javax.swing.JSlider();
        lblMinMotifSizeValue = new javax.swing.JLabel();
        lblMaxMotifSizeValue = new javax.swing.JLabel();
        pnlVariationOptions = new javax.swing.JPanel();
        slAllowedInterval = new javax.swing.JSlider();
        lblAllowedInterval = new javax.swing.JLabel();
        lblAllowedIntervalValue = new javax.swing.JLabel();
        pnlRhythmicOptions = new javax.swing.JPanel();
        lblMaxMotifExtension = new javax.swing.JLabel();
        slMaxMotifExtention = new javax.swing.JSlider();
        lblMaxMotifExtensionValue = new javax.swing.JLabel();
        pnlButtons = new javax.swing.JPanel();
        btnDetect = new javax.swing.JButton();
        btnCancel = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Detection Options");
        setMinimumSize(new java.awt.Dimension(449, 420));
        setPreferredSize(new java.awt.Dimension(400, 400));
        setResizable(false);

        pnlOptions.setMinimumSize(new java.awt.Dimension(449, 500));
        pnlOptions.setPreferredSize(new java.awt.Dimension(400, 200));
        pnlOptions.setLayout(new java.awt.BorderLayout());

        pnlGeneral.setBorder(javax.swing.BorderFactory.createTitledBorder("General"));
        pnlGeneral.setPreferredSize(new java.awt.Dimension(624, 150));

        lblMinMotifSize.setText("min motif size");

        lblMaxMotifSize.setText("max motif size");

        slMinMotifSize.setMaximum(7);
        slMinMotifSize.setMinimum(3);
        slMinMotifSize.setValue(3);
        slMinMotifSize.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slMinMotifSizeStateChanged(evt);
            }
        });

        slMaxMotifSize.setMaximum(12);
        slMaxMotifSize.setMinimum(7);
        slMaxMotifSize.setValue(7);
        slMaxMotifSize.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slMaxMotifSizeStateChanged(evt);
            }
        });

        lblMinMotifSizeValue.setText("3");

        lblMaxMotifSizeValue.setText("7");
        lblMaxMotifSizeValue.setToolTipText("");

        javax.swing.GroupLayout pnlGeneralLayout = new javax.swing.GroupLayout(pnlGeneral);
        pnlGeneral.setLayout(pnlGeneralLayout);
        pnlGeneralLayout.setHorizontalGroup(
            pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlGeneralLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlGeneralLayout.createSequentialGroup()
                        .addComponent(slMinMotifSize, javax.swing.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblMinMotifSizeValue))
                    .addGroup(pnlGeneralLayout.createSequentialGroup()
                        .addGroup(pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblMinMotifSize)
                            .addComponent(lblMaxMotifSize))
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(pnlGeneralLayout.createSequentialGroup()
                        .addComponent(slMaxMotifSize, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblMaxMotifSizeValue)))
                .addContainerGap())
        );
        pnlGeneralLayout.setVerticalGroup(
            pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlGeneralLayout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addComponent(lblMinMotifSize)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlGeneralLayout.createSequentialGroup()
                        .addComponent(slMinMotifSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblMaxMotifSize))
                    .addComponent(lblMinMotifSizeValue))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGroup(pnlGeneralLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(slMaxMotifSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblMaxMotifSizeValue))
                .addGap(41, 41, 41))
        );

        pnlOptions.add(pnlGeneral, java.awt.BorderLayout.PAGE_START);

        pnlVariationOptions.setBorder(javax.swing.BorderFactory.createTitledBorder("Variation Options"));
        pnlVariationOptions.setMaximumSize(new java.awt.Dimension(449, 100));
        pnlVariationOptions.setMinimumSize(new java.awt.Dimension(449, 100));
        pnlVariationOptions.setName("");
        pnlVariationOptions.setPreferredSize(new java.awt.Dimension(449, 100));

        slAllowedInterval.setMaximum(5);
        slAllowedInterval.setMinimum(1);
        slAllowedInterval.setValue(1);
        slAllowedInterval.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slAllowedIntervalStateChanged(evt);
            }
        });

        lblAllowedInterval.setText("allowed interval variation (in halftones)");

        lblAllowedIntervalValue.setText("1");

        javax.swing.GroupLayout pnlVariationOptionsLayout = new javax.swing.GroupLayout(pnlVariationOptions);
        pnlVariationOptions.setLayout(pnlVariationOptionsLayout);
        pnlVariationOptionsLayout.setHorizontalGroup(
            pnlVariationOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlVariationOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlVariationOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlVariationOptionsLayout.createSequentialGroup()
                        .addComponent(lblAllowedInterval)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(pnlVariationOptionsLayout.createSequentialGroup()
                        .addComponent(slAllowedInterval, javax.swing.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblAllowedIntervalValue)))
                .addContainerGap())
        );
        pnlVariationOptionsLayout.setVerticalGroup(
            pnlVariationOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlVariationOptionsLayout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addComponent(lblAllowedInterval)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlVariationOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblAllowedIntervalValue)
                    .addComponent(slAllowedInterval, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(169, Short.MAX_VALUE))
        );

        pnlOptions.add(pnlVariationOptions, java.awt.BorderLayout.CENTER);

        pnlRhythmicOptions.setBorder(javax.swing.BorderFactory.createTitledBorder("Rhythmic Options"));
        pnlRhythmicOptions.setPreferredSize(new java.awt.Dimension(493, 100));

        lblMaxMotifExtension.setText("max motif match extension");

        slMaxMotifExtention.setMaximum(5);
        slMaxMotifExtention.setMinimum(1);
        slMaxMotifExtention.setValue(3);
        slMaxMotifExtention.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                slMaxMotifExtentionStateChanged(evt);
            }
        });

        lblMaxMotifExtensionValue.setText("3");
        lblMaxMotifExtensionValue.setToolTipText("");

        javax.swing.GroupLayout pnlRhythmicOptionsLayout = new javax.swing.GroupLayout(pnlRhythmicOptions);
        pnlRhythmicOptions.setLayout(pnlRhythmicOptionsLayout);
        pnlRhythmicOptionsLayout.setHorizontalGroup(
            pnlRhythmicOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlRhythmicOptionsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlRhythmicOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlRhythmicOptionsLayout.createSequentialGroup()
                        .addComponent(lblMaxMotifExtension)
                        .addGap(0, 288, Short.MAX_VALUE))
                    .addGroup(pnlRhythmicOptionsLayout.createSequentialGroup()
                        .addComponent(slMaxMotifExtention, javax.swing.GroupLayout.DEFAULT_SIZE, 407, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblMaxMotifExtensionValue)))
                .addContainerGap())
        );
        pnlRhythmicOptionsLayout.setVerticalGroup(
            pnlRhythmicOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlRhythmicOptionsLayout.createSequentialGroup()
                .addGap(15, 15, 15)
                .addComponent(lblMaxMotifExtension)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlRhythmicOptionsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblMaxMotifExtensionValue)
                    .addComponent(slMaxMotifExtention, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(19, Short.MAX_VALUE))
        );

        pnlOptions.add(pnlRhythmicOptions, java.awt.BorderLayout.PAGE_END);

        getContentPane().add(pnlOptions, java.awt.BorderLayout.CENTER);

        pnlButtons.setPreferredSize(new java.awt.Dimension(400, 40));
        pnlButtons.setLayout(new java.awt.FlowLayout(java.awt.FlowLayout.LEFT, 2, 5));

        btnDetect.setText("detect");
        btnDetect.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnDetectActionPerformed(evt);
            }
        });
        pnlButtons.add(btnDetect);

        btnCancel.setText("cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });
        pnlButtons.add(btnCancel);

        getContentPane().add(pnlButtons, java.awt.BorderLayout.PAGE_END);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btnDetectActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnDetectActionPerformed
        MotifDetection mDetection = new MotifDetection(slMinMotifSize.getValue(), slMaxMotifSize.getValue(), slAllowedInterval.getValue(), slMaxMotifExtention.getValue());
       
        HashMap<MotifType, ArrayList<IMotif>> detectedMotifs = mDetection.detect(detectionPhrase);
        
        int repCount = detectedMotifs.get(MotifType.REPETITION).size();
        int varCount = detectedMotifs.get(MotifType.VARIATION).size();
        int rhyCount = detectedMotifs.get(MotifType.RHYTHMIC).size();
        
        JOptionPane.showMessageDialog(this, "Found:\n   " + repCount + " repetitive motifs\n   " + varCount + " variation motifs\n   " + rhyCount +" rhytmic motifs", "Detection results", JOptionPane.INFORMATION_MESSAGE);
        
        parent.setDetectedMotifs(detectedMotifs);
        
        dispose();
    }//GEN-LAST:event_btnDetectActionPerformed

    private void slMinMotifSizeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slMinMotifSizeStateChanged
        lblMinMotifSizeValue.setText("" + slMinMotifSize.getValue());
    }//GEN-LAST:event_slMinMotifSizeStateChanged

    private void slMaxMotifSizeStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slMaxMotifSizeStateChanged
        lblMaxMotifSizeValue.setText("" + slMaxMotifSize.getValue());
    }//GEN-LAST:event_slMaxMotifSizeStateChanged

    private void slAllowedIntervalStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slAllowedIntervalStateChanged
        lblAllowedIntervalValue.setText("" + slAllowedInterval.getValue());
    }//GEN-LAST:event_slAllowedIntervalStateChanged

    private void slMaxMotifExtentionStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_slMaxMotifExtentionStateChanged
        lblMaxMotifExtensionValue.setText("" + slMaxMotifExtention.getValue());
    }//GEN-LAST:event_slMaxMotifExtentionStateChanged

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(DetectionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(DetectionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(DetectionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(DetectionDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the dialog
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                DetectionDialog dialog = new DetectionDialog(new javax.swing.JFrame(), true);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnCancel;
    private javax.swing.JButton btnDetect;
    private javax.swing.JLabel lblAllowedInterval;
    private javax.swing.JLabel lblAllowedIntervalValue;
    private javax.swing.JLabel lblMaxMotifExtension;
    private javax.swing.JLabel lblMaxMotifExtensionValue;
    private javax.swing.JLabel lblMaxMotifSize;
    private javax.swing.JLabel lblMaxMotifSizeValue;
    private javax.swing.JLabel lblMinMotifSize;
    private javax.swing.JLabel lblMinMotifSizeValue;
    private javax.swing.JPanel pnlButtons;
    private javax.swing.JPanel pnlGeneral;
    private javax.swing.JPanel pnlOptions;
    private javax.swing.JPanel pnlRhythmicOptions;
    private javax.swing.JPanel pnlVariationOptions;
    private javax.swing.JSlider slAllowedInterval;
    private javax.swing.JSlider slMaxMotifExtention;
    private javax.swing.JSlider slMaxMotifSize;
    private javax.swing.JSlider slMinMotifSize;
    // End of variables declaration//GEN-END:variables
}
