/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package gui;

import data.IMotif;
import data.MotifType;
import database.DatabaseInterface;
import java.util.ArrayList;
import java.util.HashMap;
import javax.swing.DefaultListModel;
import javax.swing.JOptionPane;

/**
 *
 * @author smuRf
 */
public class MotifAddDialog extends javax.swing.JDialog {
    private DatabaseInterface databaseInterface;
    private HashMap<String, Integer> categories;
    private int[][] idList;
    private HashMap<MotifType, ArrayList<IMotif>> detectedMotifs;
    private String username;
    private data.MotifType activeMotifType;
    private int selectedListIndex = 0;
    private MainGui parent;
    
    /**
     * Creates new form MotifAddDialog
     */
    public MotifAddDialog(java.awt.Frame parent, boolean modal, int [][] idList, data.MotifType activeMotifType, String username, HashMap<MotifType, ArrayList<IMotif>> detectedMotifs) {
        super(parent, modal);
        initComponents();
        
        this.parent = (MainGui) parent;
        
        this.idList = idList;
        this.activeMotifType = activeMotifType;
        this.username = username;
        this.detectedMotifs = detectedMotifs;
        
        databaseInterface = new DatabaseInterface(MainGui.DB_USER, MainGui.DB_PASSWORD, MainGui.DB_URL);
        
        categories = databaseInterface.getCategories(this.username);
        
        DefaultListModel listModel = (DefaultListModel)listCategories.getModel();
        
        for(String name:categories.keySet())
            listModel.addElement(name);
        
        listCategories.setSelectedIndex(0);
        
        if(idList[0].length != 1)
            cbEquiMotifs.setEnabled(false);
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        spCategories = new javax.swing.JScrollPane();
        listCategories = new javax.swing.JList();
        lblCategories = new javax.swing.JLabel();
        cbNewCategory = new javax.swing.JCheckBox();
        tfNewCategory = new javax.swing.JTextField();
        cbEquiMotifs = new javax.swing.JCheckBox();
        btnCancel = new javax.swing.JButton();
        btnAdd = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("add motifs");
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        listCategories.setModel(new DefaultListModel());
        spCategories.setViewportView(listCategories);

        lblCategories.setText("categories:");

        cbNewCategory.setText("new category:");
        cbNewCategory.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cbNewCategoryActionPerformed(evt);
            }
        });

        tfNewCategory.setEditable(false);

        cbEquiMotifs.setText("add sub-motifs");

        btnCancel.setText("Cancel");
        btnCancel.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelActionPerformed(evt);
            }
        });

        btnAdd.setText("Add");
        btnAdd.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnAddActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(cbEquiMotifs, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(cbNewCategory, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(spCategories, javax.swing.GroupLayout.PREFERRED_SIZE, 286, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(tfNewCategory))
                .addContainerGap())
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(btnAdd)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btnCancel)
                .addContainerGap(270, Short.MAX_VALUE))
            .addGroup(layout.createSequentialGroup()
                .addGap(10, 10, 10)
                .addComponent(lblCategories, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addGap(297, 297, 297))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblCategories)
                    .addComponent(spCategories, javax.swing.GroupLayout.PREFERRED_SIZE, 104, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbNewCategory)
                    .addComponent(tfNewCategory, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(cbEquiMotifs)
                .addGap(18, 18, 18)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnCancel)
                    .addComponent(btnAdd))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void cbNewCategoryActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cbNewCategoryActionPerformed
        if(cbNewCategory.isSelected())
        {
            lblCategories.setEnabled(false);
            listCategories.setEnabled(false);
            tfNewCategory.setEditable(true);
            selectedListIndex = listCategories.getSelectedIndex();
            listCategories.clearSelection();
        }
        else
        {
            lblCategories.setEnabled(true);
            listCategories.setEnabled(true);
            tfNewCategory.setEditable(false);
            listCategories.setSelectedIndex(selectedListIndex);
            tfNewCategory.setText("");
        }
    }//GEN-LAST:event_cbNewCategoryActionPerformed

    private void btnAddActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnAddActionPerformed
        int categoryId;
        String categoryName;
        
        if(cbNewCategory.isSelected())
        {
            categoryName = tfNewCategory.getText();
            if(categoryName.isEmpty())
            {
                JOptionPane.showMessageDialog(this, "You have to enter a category name", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
            
            databaseInterface.insertCategory(categoryName, parent.getLoggedInUsername());
        }
        else
        {
            categoryName = (String) listCategories.getSelectedValue();
            if(categoryName == null)
            {
                JOptionPane.showMessageDialog(this, "You have to select a category", "Error", JOptionPane.ERROR_MESSAGE);
                return;
            }
        }
        
        categoryId = databaseInterface.getCategoryIdForName(categoryName);
        
        for(int ids[]:idList)
        {
            if(ids.length == 1)
            {
                databaseInterface.insertMotif(detectedMotifs.get(activeMotifType).get(ids[0]), username, categoryId);

                if(cbEquiMotifs.isSelected())
                {
                    for(IMotif equiMotif:detectedMotifs.get(activeMotifType).get(ids[0]).getEquiMotifs())
                    {
                        databaseInterface.insertMotif(equiMotif, username, categoryId);
                    }
                }
            }
            if(ids.length == 2)
                databaseInterface.insertMotif(detectedMotifs.get(activeMotifType).get(ids[1]).getEquiMotif(ids[0]), username, categoryId);
        }
        
        JOptionPane.showMessageDialog(this, "Motif successfully added", "Add", JOptionPane.INFORMATION_MESSAGE);
        dispose();
    }//GEN-LAST:event_btnAddActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        databaseInterface.closeConnection();
    }//GEN-LAST:event_formWindowClosing

    private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelActionPerformed
        dispose();
    }//GEN-LAST:event_btnCancelActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /*
         * Set the Nimbus look and feel
         */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /*
         * If Nimbus (introduced in Java SE 6) is not available, stay with the
         * default look and feel. For details see
         * http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MotifAddDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MotifAddDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MotifAddDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MotifAddDialog.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /*
         * Create and display the dialog
         */
        java.awt.EventQueue.invokeLater(new Runnable() {

            public void run() {
                MotifAddDialog dialog = new MotifAddDialog(new javax.swing.JFrame(), true, null, null, "", null);
                dialog.addWindowListener(new java.awt.event.WindowAdapter() {

                    @Override
                    public void windowClosing(java.awt.event.WindowEvent e) {
                        System.exit(0);
                    }
                });
                dialog.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnAdd;
    private javax.swing.JButton btnCancel;
    private javax.swing.JCheckBox cbEquiMotifs;
    private javax.swing.JCheckBox cbNewCategory;
    private javax.swing.JLabel lblCategories;
    private javax.swing.JList listCategories;
    private javax.swing.JScrollPane spCategories;
    private javax.swing.JTextField tfNewCategory;
    // End of variables declaration//GEN-END:variables
}
